% Hansen - Chernozhukov IV-QR


clear all;
%diary path/filename.out;
%disp('                   Chernozhukov - Hansen IV-QR.OUT');
%disp(' ');
%disp(' ');

% LOAD DATA AND CONSTRUCT VARIABLES

 %load path/filename.raw; 
load y.txt;
load d.txt;
load x.txt;
load z.txt;
%load sex.txt;
 
% CONSTRUCT USING C - H NOTIONS
% y - dependent variable
% d - RHS endogenous variable - THIS VERSION: TEMP & REG
% x - covariates
% z - excluded instruments

%y = filename(:,1);

%d = filename(:,[2 3]);

%z = filename(:,[4 5]);
     
%x = filename(:,[6 7 8 9 10 11 12 13 14 15]);

w = [z,x,ones(size(y))];

% Generate linear projection of D on {X,Z} to use as instrument.
dhat = w*inv(w'*w)*(w'*d);

clear filename;
pack;

%Q = [0.1:0.1:0.9];
Q = [0.01:0.01:0.99];
%Q = [0.1];
 disp('D = TEMPEMP & REGEMP');
 disp(' ');
 disp('WITH COVARIATES');
 disp(' ');
 disp('      QUANTILE REGRESSION');
 disp(' ');
 
% Quantile Regression
result_qr_est = [ ];
result_qr_se = [ ];
 
 for i=1:length(Q);
  q=Q(i);
  disp(sprintf('Quantile %1.2f :\n',q));
  bqrq = rq([d,x,ones(size(y))],y,q);  
  bqrq = vcqr(bqrq,y,[d,x],q)   
  result1 = bqrq(:,1);
  result2 = bqrq(:,2);
  result_qr_est = [result_qr_est result1];
  result_qr_se = [result_qr_se result2];
  clear result1 result2
 end;
result_qr_est = result_qr_est';
result_qr_est = result_qr_est(:,1:2);
result_qr_se = result_qr_se';
result_qr_se = result_qr_se(:,1:2);



%disp(' ');
%disp('     IV QUANTILE REGRESSION');
%disp(' ');
%disp('A = () & D = TEMPEMP & REGEMP');
%disp(' ');
% A = [;]';        % Grid search region

% IV Quantile Regression

A = [ ]';  

result_ivqr_est = [ ];
result_ivqr_se = [ ];

for i=1:length(Q);
 q=Q(i);
 disp(sprintf('Quantile %1.2f :\n',q));
 biqrq = inv_qr_oid(y,d,x,dhat,q,A);
 biqrq = vciqr_oid(biqrq,y,d,x,z,q)
 result1 = biqrq(:,1);
 result2 = biqrq(:,2);
 result_ivqr_est = [result_ivqr_est result1];
 result_ivqr_se = [result_ivqr_se result2];
 clear result1 result2
end;

result_ivqr_est = result_ivqr_est';
result_ivqr_est = result_ivqr_est(:,1:2);
result_ivqr_se = result_ivqr_se';
result_ivqr_se = result_ivqr_se(:,1:2);

% Saving Result
result = [result_qr_est result_qr_se result_ivqr_est result_ivqr_se];
save qr_result.txt result  -ascii -tabs;

%diary off;
exit;